#! /usr/bin/env node
import * as Fs from 'fs';
import * as Path from 'path';
import 'rescript/lib/es6/js_math.js';
import * as Caml_option from 'rescript/lib/es6/caml_option.js';
import * as Js_exn from 'rescript/lib/es6/js_exn.js';
import * as S$RescriptStruct from 'rescript-struct/src/S.bs.mjs';
import * as Process from 'process';
import Minimist from 'minimist';
import * as Caml_js_exceptions from 'rescript/lib/es6/caml_js_exceptions.js';
import * as Colorette from 'colorette';

// Generated by ReScript, PLEASE EDIT WITH CARE

function last(a) {
  return a[a.length - 1 | 0];
}
/* No side effect */

// Generated by ReScript, PLEASE EDIT WITH CARE

function forEach(opt, f) {
  if (opt !== undefined) {
    return f(Caml_option.valFromOption(opt));
  }
  
}

function getExnWithMessage(x, message) {
  if (x !== undefined) {
    return Caml_option.valFromOption(x);
  } else {
    return Js_exn.raiseError(message);
  }
}

function map$1(opt, f) {
  if (opt !== undefined) {
    return Caml_option.some(f(Caml_option.valFromOption(opt)));
  }
  
}
/* No side effect */

// Generated by ReScript, PLEASE EDIT WITH CARE
var defaultProhibitedModuleNames = ["Belt", "Js", "ReScriptJs"];
function fromBscFlag(bscFlag) {
  if (bscFlag.includes("-open")) {
    return bscFlag.replace("-open", "").trim().split(".")[0];
  }
}
function fromPath(path) {
  var pathWithoutResExtension = path.replace(/\.resi?$/, "");
  if (path.length === pathWithoutResExtension.length) {
    return;
  } else {
    return getExnWithMessage(last(pathWithoutResExtension.split("/")), "After splitting path by slashes there should always be at least one item.");
  }
}
function isSubmodule(moduleName, ofModule) {
  return moduleName.startsWith(ofModule + "_");
}
var defaultStdlibModuleName = "Stdlib";
/* No side effect */

// Generated by ReScript, PLEASE EDIT WITH CARE

function map(opt, f) {
  if (opt.TAG === "Ok") {
    return {
            TAG: "Ok",
            _0: f(opt._0)
          };
  } else {
    return opt;
  }
}

function flatMap(opt, f) {
  if (opt.TAG === "Ok") {
    return f(opt._0);
  } else {
    return opt;
  }
}

function mapError(r, f) {
  if (r.TAG === "Ok") {
    return r;
  } else {
    return {
            TAG: "Error",
            _0: f(r._0)
          };
  }
}
/* No side effect */

// Generated by ReScript, PLEASE EDIT WITH CARE
function getGlobalyOpenedModulesSet(resConfig) {
  var set = new Set();
  resConfig.bscFlags.forEach(function (bscFlag) {
    forEach(fromBscFlag(bscFlag), function (moduleName) {
      set.add(moduleName);
    });
  });
  return set;
}
function hasGloballyOpenedModule(resConfig, moduleName) {
  var globalyOpenedModulesSet = getGlobalyOpenedModulesSet(resConfig);
  return globalyOpenedModulesSet.has(moduleName);
}
function lint$1(resConfig, prohibitedModuleNames) {
  var globalyOpenedModulesSet = getGlobalyOpenedModulesSet(resConfig);
  var maybeOpenedProhibitedModule = prohibitedModuleNames.find(function (prohibitedModule) {
    return globalyOpenedModulesSet.has(prohibitedModule);
  });
  if (maybeOpenedProhibitedModule !== undefined) {
    return {
      TAG: "Error",
      _0: {
        NAME: "HAS_OPENED_PROHIBITED_MODULE",
        VAL: Caml_option.valFromOption(maybeOpenedProhibitedModule)
      }
    };
  } else {
    return {
      TAG: "Ok",
      _0: undefined
    };
  }
}
var struct$1 = S$RescriptStruct.object(function (s) {
  return {
    bscFlags: s.o("bsc-flags", S$RescriptStruct.array(S$RescriptStruct.string), [])
  };
});
function fromJsonString$1(jsonString) {
  return mapError(S$RescriptStruct.parseJsonStringWith(jsonString, struct$1), S$RescriptStruct.$$Error.message);
}
/* struct Not a pure module */

// Generated by ReScript, PLEASE EDIT WITH CARE
function make$a(projectPath, ignoreWithoutStdlibOpen, ignorePaths) {
  return {
    projectPath: projectPath,
    ignoreWithoutStdlibOpen: ignoreWithoutStdlibOpen,
    stdlibModuleName: defaultStdlibModuleName,
    ignorePaths: ignorePaths
  };
}
function getProjectPath(config) {
  return config.projectPath;
}
function getStdlibModuleName(config) {
  return config.stdlibModuleName;
}
function checkShouldIngoreResFileIssuesBeforeStdlibOpen(config, resConfig) {
  if (config.ignoreWithoutStdlibOpen) {
    return !hasGloballyOpenedModule(resConfig, config.stdlibModuleName);
  } else {
    return false;
  }
}
function checkIsIgnoredPath(config, relativePath) {
  return config.ignorePaths.some(function (ignorePath) {
    return relativePath.startsWith(ignorePath);
  });
}
/* ResConfig Not a pure module */

// Generated by ReScript, PLEASE EDIT WITH CARE

function make$9(path, kind) {
  return {
    path: path,
    kind: kind
  };
}
function getLink(lintIssue) {
  var match = lintIssue.kind;
  if (match.TAG === "InvalidStdlibParentDirName") {
    return lintIssue.path;
  } else {
    return lintIssue.path + ":" + match.line.toString();
  }
}
function getMessage(lintIssue) {
  var match = lintIssue.kind;
  switch (match.TAG) {
    case "ProhibitedModuleOpen":
      return "Found \"" + match.prohibitedModuleName + "\" module open.";
    case "ProhibitedModuleInclude":
      return "Found \"" + match.prohibitedModuleName + "\" module include.";
    case "ProhibitedModuleAssign":
    case "ProhibitedModuleUsage":
      return "Found \"" + match.prohibitedModuleName + "\" module usage.";
    case "InvalidStdlibParentDirName":
      return "The \"" + match.stdlibParentDirName + "\" is an invalid directory name for custom standary library related files. Put the files to the directory with the name \"stdlib\" to make it easier to find them.";
  }
}
/* No side effect */

// Generated by ReScript, PLEASE EDIT WITH CARE

function make$8() {
  return [];
}
function addIssue(lintContext, lintIssue) {
  lintContext.push(lintIssue);
}
function getIssues(lintContext) {
  return lintContext;
}
/* No side effect */

// Generated by ReScript, PLEASE EDIT WITH CARE
function make$7(content, path) {
  return {
    content: content,
    path: path,
    moduleName: getExnWithMessage(fromPath(path), "A ResFile should always have a valid module name.")
  };
}
function normalizeName(name) {
  return name.replace(/\W/g, "").toLowerCase();
}
function lint(resFile, lintContext, prohibitedModuleNames, stdlibModuleName, ignoreIssuesBeforeStdlibOpen) {
  if (resFile.moduleName === stdlibModuleName || isSubmodule(resFile.moduleName, stdlibModuleName)) {
    var stdlibParentDirName = getExnWithMessage(resFile.path.split("/").at(-2), "A ResFile should always have a directory name");
    if (normalizeName(stdlibModuleName) !== normalizeName(stdlibParentDirName)) {
      return addIssue(lintContext, make$9(resFile.path, {
        TAG: "InvalidStdlibParentDirName",
        stdlibParentDirName: stdlibParentDirName
      }));
    } else {
      return;
    }
  }
  var shouldIgnoreLineRef = {
    contents: ignoreIssuesBeforeStdlibOpen
  };
  resFile.content.split("\n").forEach(function (line, idx) {
    var match = shouldIgnoreLineRef.contents;
    if (match) {
      if (ignoreIssuesBeforeStdlibOpen && new RegExp("^open " + stdlibModuleName + "$").test(line)) {
        shouldIgnoreLineRef.contents = false;
        return;
      } else {
        return;
      }
    } else {
      prohibitedModuleNames.forEach(function (prohibitedModuleName) {
        var result = flatMap(flatMap(flatMap(new RegExp("^ *open " + prohibitedModuleName + "($|\\.)").test(line) ? {
          TAG: "Error",
          _0: make$9(resFile.path, {
            TAG: "ProhibitedModuleOpen",
            line: idx + 1 | 0,
            prohibitedModuleName: prohibitedModuleName
          })
        } : {
          TAG: "Ok",
          _0: undefined
        }, function () {
          if (new RegExp("^ *include " + prohibitedModuleName + "($|\\.)").test(line)) {
            return {
              TAG: "Error",
              _0: make$9(resFile.path, {
                TAG: "ProhibitedModuleInclude",
                line: idx + 1 | 0,
                prohibitedModuleName: prohibitedModuleName
              })
            };
          } else {
            return {
              TAG: "Ok",
              _0: undefined
            };
          }
        }), function () {
          if (new RegExp("^ *module.+= " + prohibitedModuleName + "($|\\.)").test(line)) {
            return {
              TAG: "Error",
              _0: make$9(resFile.path, {
                TAG: "ProhibitedModuleAssign",
                line: idx + 1 | 0,
                prohibitedModuleName: prohibitedModuleName
              })
            };
          } else {
            return {
              TAG: "Ok",
              _0: undefined
            };
          }
        }), function () {
          if (new RegExp("(\\W|^)" + prohibitedModuleName + "\\.").test(line)) {
            return {
              TAG: "Error",
              _0: make$9(resFile.path, {
                TAG: "ProhibitedModuleUsage",
                line: idx + 1 | 0,
                prohibitedModuleName: prohibitedModuleName
              })
            };
          } else {
            return {
              TAG: "Ok",
              _0: undefined
            };
          }
        });
        if (result.TAG === "Ok") {
          return;
        } else {
          return addIssue(lintContext, result._0);
        }
      });
      return;
    }
  });
}
function checkIsResFile(dirItem) {
  if (dirItem.endsWith(".res")) {
    return true;
  } else {
    return dirItem.endsWith(".resi");
  }
}
/* No side effect */

// Generated by ReScript, PLEASE EDIT WITH CARE
function getProjectDirs(projectDirs) {
  return projectDirs;
}
var struct = S$RescriptStruct.object(function (s) {
  return s.f("dirs", S$RescriptStruct.array(S$RescriptStruct.string));
});
function fromJsonString(jsonString) {
  return mapError(S$RescriptStruct.parseJsonStringWith(jsonString, struct), S$RescriptStruct.$$Error.message);
}
/* struct Not a pure module */

// Generated by ReScript, PLEASE EDIT WITH CARE
function make$6(loadResConfig, loadSourceDirs) {
  return function (config) {
    return flatMap(flatMap(flatMap(mapError(loadResConfig(config), function (loadResConfigError) {
      return {
        TAG: "ResConfigParseFailure",
        _0: loadResConfigError._0
      };
    }), function (resConfig) {
      var match = lint$1(resConfig, defaultProhibitedModuleNames);
      if (match.TAG === "Ok") {
        return {
          TAG: "Ok",
          _0: resConfig
        };
      } else {
        return {
          TAG: "Error",
          _0: {
            TAG: "ResConfigHasOpenedProhibitedModule",
            _0: match._0.VAL
          }
        };
      }
    }), function (resConfig) {
      var sourceDirs = loadSourceDirs(config);
      if (sourceDirs.TAG === "Ok") {
        return {
          TAG: "Ok",
          _0: [resConfig, sourceDirs._0]
        };
      }
      var loadSourceDirsError = sourceDirs._0;
      var tmp;
      tmp = typeof loadSourceDirsError !== "object" ? "RescriptCompilerArtifactsNotFound" : {
        TAG: "SourceDirsParseFailure",
        _0: loadSourceDirsError._0
      };
      return {
        TAG: "Error",
        _0: tmp
      };
    }), function (param) {
      var resConfig = param[0];
      var resFiles = [];
      getProjectDirs(param[1]).forEach(function (sourceDir) {
        var fullDirPath = Path.resolve(getProjectPath(config), sourceDir);
        Fs.readdirSync(fullDirPath).forEach(function (dirItem) {
          if (!(checkIsResFile(dirItem) && !checkIsIgnoredPath(config, sourceDir + "/" + dirItem))) {
            return;
          }
          var resFilePath = fullDirPath + "/" + dirItem;
          var resFile = make$7(Fs.readFileSync(resFilePath, {
            encoding: "utf8"
          }).toString(), resFilePath);
          resFiles.push(resFile);
        });
      });
      var lintContext = make$8();
      resFiles.forEach(function (resFile) {
        lint(resFile, lintContext, defaultProhibitedModuleNames, getStdlibModuleName(config), checkShouldIngoreResFileIssuesBeforeStdlibOpen(config, resConfig));
      });
      var lintIssues = getIssues(lintContext);
      if (lintIssues.length !== 0) {
        return {
          TAG: "Error",
          _0: {
            TAG: "LintFailedWithIssues",
            _0: lintIssues
          }
        };
      } else {
        return {
          TAG: "Ok",
          _0: undefined
        };
      }
    });
  };
}
/* fs Not a pure module */

// Generated by ReScript, PLEASE EDIT WITH CARE
function make$5(runLintCommand, runHelpCommand, runHelpLintCommand, exitConsoleWithError) {
  return function () {
    var commandArguments = Process.argv.slice(2);
    var result = map(mapError(S$RescriptStruct.parseWith(Minimist(commandArguments), S$RescriptStruct.union([S$RescriptStruct.$$Object.strict(S$RescriptStruct.object(function (s) {
      s.t("_", []);
      return "Help";
    })), S$RescriptStruct.$$Object.strict(S$RescriptStruct.object(function (s) {
      s.t("_", ["help"]);
      return "Help";
    })), S$RescriptStruct.$$Object.strict(S$RescriptStruct.object(function (s) {
      s.t("_", ["help", "lint"]);
      return "LintHelp";
    })), S$RescriptStruct.$$Object.strict(S$RescriptStruct.object(function (s) {
      s.t("_", ["lint"]);
      return {
        TAG: "Lint",
        _0: make$a(s.f("project-path", S$RescriptStruct.$$Option.getOrWith(S$RescriptStruct.option(S$RescriptStruct.string), function () {
          return Process.cwd();
        })), s.o("ignore-without-stdlib-open", S$RescriptStruct.bool, false), s.o("ignore-path", S$RescriptStruct.union([S$RescriptStruct.variant(S$RescriptStruct.string, function (s) {
          return [s];
        }), S$RescriptStruct.array(S$RescriptStruct.string)]), []))
      };
    }))])), function (error) {
      var unionErrors = error.code;
      if (typeof unionErrors !== "object") {
        return Js_exn.raiseError("Parsed error always must have the InvalidUnion code");
      }
      if (unionErrors.TAG !== "InvalidUnion") {
        return Js_exn.raiseError("Parsed error always must have the InvalidUnion code");
      }
      var maybeIllegalOptionName = map$1(unionErrors._0.find(function (error) {
        var match = error.code;
        if (typeof match !== "object" || match.TAG !== "ExcessField") {
          return false;
        } else {
          return true;
        }
      }), function (excessFieldError) {
        var illegalOptionName = excessFieldError.code;
        if (typeof illegalOptionName !== "object" || illegalOptionName.TAG !== "ExcessField") {
          return Js_exn.raiseError("The excessFieldError always must have the ExcessField code");
        } else {
          return illegalOptionName._0;
        }
      });
      if (maybeIllegalOptionName !== undefined) {
        return {
          TAG: "IllegalOption",
          optionName: maybeIllegalOptionName
        };
      } else {
        return "CommandNotFound";
      }
    }), function (command) {
      if (typeof command !== "object") {
        if (command === "Help") {
          return runHelpCommand();
        } else {
          return runHelpLintCommand();
        }
      } else {
        return runLintCommand(command._0);
      }
    });
    if (result.TAG === "Ok") {
      return;
    }
    var error = result._0;
    if (typeof error !== "object") {
      return exitConsoleWithError("Command not found: " + commandArguments.join(" "));
    } else {
      return exitConsoleWithError("Illegal option: " + error.optionName);
    }
  };
}
/* Config Not a pure module */

// Generated by ReScript, PLEASE EDIT WITH CARE
function make$4() {
  return function (config) {
    var tmp;
    try {
      tmp = Fs.readFileSync(Path.resolve(getProjectPath(config), "bsconfig.json"), {
        encoding: "utf8"
      }).toString();
    } catch (raw_err) {
      var err = Caml_js_exceptions.internalToOCamlException(raw_err);
      if (err.RE_EXN_ID === Js_exn.$$Error) {
        if (err._1.code === "ENOENT") {
          tmp = Fs.readFileSync(Path.resolve(getProjectPath(config), "rescript.json"), {
            encoding: "utf8"
          }).toString();
        } else {
          throw err;
        }
      } else {
        throw err;
      }
    }
    return mapError(fromJsonString$1(tmp), function (error) {
      return {
        TAG: "ParsingFailure",
        _0: error
      };
    });
  };
}
/* fs Not a pure module */

// Generated by ReScript, PLEASE EDIT WITH CARE
function make$3() {
  return function (config) {
    var tmp;
    try {
      tmp = {
        TAG: "Ok",
        _0: Fs.readFileSync(Path.resolve(getProjectPath(config), "lib/bs/.sourcedirs.json"), {
          encoding: "utf8"
        }).toString()
      };
    } catch (exn) {
      tmp = {
        TAG: "Error",
        _0: "RescriptCompilerArtifactsNotFound"
      };
    }
    return flatMap(tmp, function (file) {
      return mapError(fromJsonString(file), function (error) {
        return {
          TAG: "ParsingFailure",
          _0: error
        };
      });
    });
  };
}
/* fs Not a pure module */

// Generated by ReScript, PLEASE EDIT WITH CARE
function make$2() {
  return function () {
    console.log(["Usage: cli [command] [options]", "", "Commands:", "  " + Colorette.bold("help") + " - Display this message", "  " + Colorette.bold("help <command>") + " - Show more information about a command", "  " + Colorette.bold("lint") + " - Lint that you use your vendored ReScript standard library over Js, Belt, etc", "", "You can find more information about the reasoning behind the tool in the documentation: " + Colorette.underline("https://github.com/DZakh/rescript-stdlib-vendorer"), ""].join("\n"));
  };
}
/* colorette Not a pure module */

// Generated by ReScript, PLEASE EDIT WITH CARE
function make$1(lint, exitConsoleWithError) {
  return function (config) {
    var error = lint(config);
    if (error.TAG === "Ok") {
      return;
    }
    var error$1 = error._0;
    if (typeof error$1 !== "object") {
      return exitConsoleWithError("Couldn't find rescript compiler artifacts in the \"./lib/bs/\" directory. Try to run compiler before the lint script.");
    }
    switch (error$1.TAG) {
      case "ResConfigParseFailure":
        return exitConsoleWithError("Failed to parse \"bsconfig.json\": " + error$1._0);
      case "SourceDirsParseFailure":
        return exitConsoleWithError("Failed to parse \".sourcedirs.json\". Check that you use compatible ReScript version. Parsing error: " + error$1._0);
      case "ResConfigHasOpenedProhibitedModule":
        return exitConsoleWithError("Lint failed: Found globally opened module " + error$1._0);
      case "LintFailedWithIssues":
        var message = error$1._0.map(function (lintIssue) {
          return [Colorette.underline(getLink(lintIssue)), getMessage(lintIssue)].join("\n");
        }).concat([Colorette.bold("Use the vendored standard library instead. Read more at: " + Colorette.underline("https://github.com/DZakh/rescript-stdlib-vendorer"))]).join("\n\n");
        return exitConsoleWithError(message);
    }
  };
}
/* colorette Not a pure module */

// Generated by ReScript, PLEASE EDIT WITH CARE
function make() {
  return function () {
    console.log(["", "Lint that you use your vendored ReScript standard library over Js, Belt, etc.", "", "Options:", " " + Colorette.bold("--project-path String") + " - Path to the project directory. It should point to where bsconfig.json is located (defaults to the current directory).", " " + Colorette.bold("--ignore-without-stdlib-open") + " - Whether linter should ignore files that don't have globally opened vendored stdlib. Convenient for gradual adoption.", " " + Colorette.bold("--ignore-path [String]") + " - Paths of files to ignore.", ""].join("\n"));
  };
}
/* colorette Not a pure module */

// Generated by ReScript, PLEASE EDIT WITH CARE
function exitConsoleWithError(message) {
  console.log(message);
  Process.exit(1);
}
var runCli = make$5(make$1(make$6(make$4(), make$3()), exitConsoleWithError), make$2(), make(), exitConsoleWithError);
runCli();
/* runCli Not a pure module */
//# sourceMappingURL=rescript-stdlib-vendorer.modern.js.map
